/* Problem URL: https://codeforces.com/gym/102346/problem/J */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    vvi cards(n, vi(14, 0));

    map<char, int> act;

    act['A'] = 1;
    act['2'] = 2;
    act['3'] = 3;
    act['4'] = 4;
    act['5'] = 5;
    act['6'] = 6;
    act['7'] = 7;
    act['8'] = 8;
    act['9'] = 9;
    act['D'] = 10;
    act['Q'] = 11;
    act['J'] = 12;
    act['K'] = 13;

    rep(i, n) {
        string a;
        cin >> a;

        repv(j, a) {
            cards[i][act[j]]++;
        }
    }

    k--;

    rep(i, n) {
        if (i == k) {
            continue;
        }

        nrep(j, 1, 14) {
            if (cards[i][j] == 4) {
                cout << i + 1 << '\n';
                return 0;
            }
        }
    }

    rep(i, n) {
        int minimal = 2;
        int choice = 13;

        int now = (i + k) % n;

        for (int j = 13; j > 0; j--) {
            if (cards[now][j] <= minimal && cards[now][j] > 0) {
                minimal = cards[now][j];
                choice = j;
            }
        }

        cards[now][choice]--;
        cards[(now + 1) % n][choice]++;

        if (now != k) {
            nrep(j, 1, 14) {
                if (cards[now][j] == 4) {
                    rep(l, n) {
                        nrep(c, 1, 14) {
                            if (cards[l][c] == 4 && l != k) {
                                cout << l + 1 << '\n';
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    }
     
    nrep(i, 1, 14) {
        if (cards[k][i] == 4) {
            cout << k + 1 << '\n';
            return 0;
        }
    }

    k = (k + 1) % n;

    while (true) {
        rep(i, n - 1) {
            int minimal = 2;
            int choice = 13;

            int now = (k + i) % n;

            for (int j = 13; j > 0; j--) {
                if (cards[now][j] <= minimal && cards[now][j] > 0) {
                    minimal = cards[now][j];
                    choice = j;
                }
            }

            cards[now][choice]--;
            cards[(now + 1) % n][choice]++;
            if (now != ((k - 1) % n + n) % n) {
                nrep(j, 1, 14) {
                    if (cards[now][j] == 4) {
                        rep(l, n) {
                            nrep(c, 1, 14) {
                                if (cards[l][c] == 4 && l != ((k - 1) % n + n) % n) {
                                    cout << l + 1 << '\n';
                                    return 0;
                                }
                            }
                        }
                    }
                }
            }
        }

        nrep(i, 1, 14) {
            if (cards[k][i] == 4) {
                cout << k + 1 << '\n';
                return 0;
            }
        }

        k = (k + 1) % n;
    }
}
